#include "Input.h"
#include <vector>

namespace midi {

void Input::setCallback( Input::MessageInCallback callback, void *userData )
{
	userCallback = callback;
    userCallbackData = userData;

	RtMidiIn::setCallback( rtmidiCallback, (void*) this );
}

void Input::rtmidiCallback( double timeStamp, std::vector<unsigned char> *messageBytes, void *callbackData )
{
	Input* input = (Input*) callbackData;

	Message* message = Message::parse(*messageBytes);
	input->userCallback( timeStamp, *message, input->userCallbackData );
	delete message;
}

}; // namespace
